<?php
defined('is_running') or die('Not an entry point...');

gpPlugin::Incl('COMMON.php');

class rifBBCloneAdmin extends rifBBCloneCommon{

	static function admn_menu($style=array(0,0,0,0,0)) {
		global $page, $addonPathData;
		global $langmessage, $addon_current_id;
		
		if(!isset($langmessage[$addon_current_id]["--ADMIN_LINKS--"]))
			common::Redirect(common::GetUrl('Admin_BBC_Configuration'));
		
		$translinks = $langmessage[$addon_current_id]["--ADMIN_LINKS--"];
		
		foreach($style as $k => $active){
			$style[$k] = "";
			if($active == 1)
				$style[$k] = ' style="color:#008c00;text-decoration:underline;"';			
		}
		
		$moreinfo = '<a style="margin-top:3px;padding-right:5px;float:right;font-weight:normal;font-style:italic;" target="_blank" href="'.$translinks["--MoreInfoLink--"].'"> | '.$langmessage[$addon_current_id]['More Info for plugin'].'... </a> ';
		
		$links = '<div style="font-weight:bold;font-size:16px;border-bottom:1px solid #dddddd;margin-bottom:20px;padding-bottom:5px;">';		
		$links .= common::Link('Admin_BBC_Global_Stats',$translinks["Admin_Link:Admin_BBC_Global_Stats"], "", $style[0])." | ";
		$links .= common::Link('Admin_BBC_Detailed_Stats',$translinks["Admin_Link:Admin_BBC_Detailed_Stats"], "", $style[1])." | ";
		$links .= common::Link('Admin_BBC_Time_Stats',$translinks["Admin_Link:Admin_BBC_Time_Stats"], "", $style[2])." | ";
		//$links .= common::Link('Admin_BBC_Show_Views',$translinks["Admin_Link:Admin_BBC_Show_Views"])." | ";
		$links .= common::Link('Admin_BBC_Configuration',$translinks["Admin_Link:Admin_BBC_Configuration"], "", $style[3])." | ";
		$links .= common::Link('Admin_BBC_OnlineGadget',$translinks["Admin_Link:Admin_BBC_OnlineGadget"], "", $style[4])." | ";
		$links .= $moreinfo;		
		$links .= '</div>';
		$links .= '<i style="display:block;margin-top:-20px;margin-bottom:20px;">NB! '.$langmessage[$addon_current_id]["If you are logged in, statistics will not be recorded"].'</i>';
		return $links;

	}
	
	static function get_config() {
		global $page, $addonPathCode, $addonRelativeCode, $addonPathData;
		
		require_once($addonPathCode."/constants.php");
		self::ConstantGlobals();
		
		self::CopyFiles();
		
		$page->css_user[] = $addonRelativeCode.'/css/bbclone.css';
		
		self::ConfigGlobals();
		
		require_once($BBC_LIB_PATH."html.php");
		require_once($BBC_LIB_PATH."selectlang.php");
		
	}
	
	function OnlineVisitorGadgetAdmin(){
		global $langmessage, $addon_current_id, $title;
		
		if( isset($_POST['save']) ){
			$VisitorsGadgetTemplate = array('html'=>$_POST['ovTextarea']);
			if( gpFiles::SaveData($addonPathData.'/template.php', 'OnlineVisitorsGadget', $VisitorsGadgetTemplate) ){
				msg($langmessage['SAVED']);
			}else{
				msg($langmessage['OOPS']);
			}
		}
		if( file_exists(self::$addonPathData.'/template.php') ){
			$VisitorsGadgetTemplate = gpFiles::Get($addonPathData.'/template.php','OnlineVisitorsGadget');
		}
		$string = htmlspecialchars($VisitorsGadgetTemplate['html']);
		echo '<h2>Simple Online Visitor Admin Page</h2>';
		echo 'version 2.0.1';
		echo '<h3>Editable area</h3>';
		echo '<div>';
		echo '<form method="post" action="'.common::GetUrl($title).'">';
		echo '<p><textarea name="ovTextarea" cols="80" rows="5">'.$string.'</textarea></p>';
		echo '<input name="save" type="submit" class="btn btn-default" value="'.$langmessage['save'].'" />&nbsp;';
		echo '<input name="reset" type="reset" value="'.$langmessage['cancel'].'" />&nbsp;';
		echo '</form></div>';
		echo '<h3>Variables</h3>';
		echo '{visitors} - Visitors counter<br />{bots} - Bots counter<br />';
	}
	
	static function ShowClickStats(){
		global $addonPathData, $addonRelativeCode, $addonPathCode, $langmessage, $addon_current_id;		
		
		$helplink = common::Link('Admin_BBC_Show_Views', $langmessage[$addon_current_id]["help"], 'bbcclickpagehelp=1', 'name="gpabox"');
		if(!rifBBCloneAdmin::NoArchive())
			$helplink .= ' ... '.common::Link('Admin_BBC_Detailed_Stats', ' '.$langmessage[$addon_current_id]["Archive"].' ', 'cmd=bbc_clickcouterstats');	
		echo "<tr>\n<td class=\"padding\">\n<table class=\"centerbox\">\n"
		."<tr><td class=\"label\" style=\"background:#ffefbf\">".$langmessage[$addon_current_id]["Click Counter Pages"]." ... ".$helplink."</td></tr><tr>\n"
		."<td style=\"padding:0\">\n";
		self::Show_ClickStats();
		echo "</td></tr></table></td></tr>\n";
	}	
	
	static function sort_ClickStats($clickstats){
		
		$_clickstats = array();
		$i = 1;
		foreach ($clickstats as $linkname => $_info){
			$_clickstats[$_info['lastclick'].':'.$i] = $_info;
			$_clickstats[$_info['lastclick'].':'.$i]['linkname'] = $linkname;
			$i++;			
		}
		krsort($_clickstats);	
		return $_clickstats;

	}
	
	static function Show_ClickStats(){
		global $langmessage, $addon_current_id, $addonPathData;

		$folder = $addonPathData.'/clickstats/';
		
		if(!file_exists($folder))
			return false;
		
		$maxglobal = 1;		
		$i = 1;
		$sortpages = array();
		foreach (glob($folder."*.php") as $filename) {			
			$id = explode('/',$filename);
			$ids = explode('.', end($id));
			$pagename = $ids[0];
		
			$_clickstats = array();			
			include($filename); 

			$backround = ($i % 2 ? 'background:#eeeeee' : '');
			$bbcclickpage = 'bbcclickpage='.$ids[0].'&gpabox=1';
			$pagelink = common::Link('Admin_BBC_Show_Views', common::indexToTitle($pagename).' ('.count($clickstats).' '.$langmessage[$addon_current_id]["links"].') ', $bbcclickpage, 'name="gpabox"');

			$_clickstats = self::sort_ClickStats($clickstats);

			$is = 1;
			$lines = "";			
			foreach ($_clickstats as $time => $info){
				if($is == 1)
					$lasttime = $time;
				
				if($is > $maxglobal)
					break;
				
				$_time = explode(":", $time);			
				$lines .= '<tr><td><b>'.$langmessage[$addon_current_id]["Last Click"].'</b> '.$info['linkname'] .'</td><td>'.date('d-m-Y H:i', $_time[0]).'</td><td>'.$info['count'].' '.$langmessage[$addon_current_id]["clicks"].'</td></tr>';				
				$is++;				
			}
			
			$sortpages[$lasttime] = '<table class="padding top" height="100%" style="border:1px solid #999999;margin:3px;height:100%;width:25%;float:left;'.$backround.'"><tr><td colspan="6" class="label">'.$pagelink.'</td></tr>'			
								.$lines
								.'</table>';
			$i++;
			
		}
		
		krsort($sortpages);
		foreach($sortpages as $print){
			echo $print;
		}
	
		//gpFiles::Save($instfile, "install");
		return true;	
	}
	
	static function Detailed_ClickStats($pageindex, $popup=true){
		global $langmessage, $addon_current_id, $addonPathData, $BBC_TIME_OFFSET;

		$folder = $addonPathData.'/clickstats/';

		if(!file_exists($folder.$pageindex.'.php')) 
			return false;
						
		include($folder.$pageindex.'.php');
		$_clickstats = self::sort_ClickStats($clickstats);	
		$_clickstats_key = key($_clickstats);
		
		$ctime = time() + ($BBC_TIME_OFFSET * 60);
		$ctimemonth = date('Ym', $ctime);		
		
		$out = "";
		$out .= '<table class="padding top" style="width:100%"><tr style="border:5px solid #eeeeee;"><td style="padding:3px;background:#ffefbf;text-align:center;font-weight:bold;" colspan="3" class="label">'.common::link(common::indexToTitle($pageindex),common::indexToTitle($pageindex)).' ('.count($clickstats).' '.$langmessage[$addon_current_id]["links"].')</td></tr>';
		$out .= '<tr style="border:5px solid #eeeeee;background:#eeeeee"><th>'.$langmessage[$addon_current_id]["Link Titles"] .'</th><th>'.$langmessage[$addon_current_id]["Last Click"].'</th><th>'.$langmessage[$addon_current_id]["Clicks Count"].'</th></tr>';
			
		foreach ($_clickstats as $time => $info){
			$_time = explode(":", $time);			
			$out .= '<tr><td><a class="moreclickstatinfo">'.$info['linkname'] .'</a></td><td>'.date('d-m-Y H:i', $_time[0]).'</td><td>'.$info['count'].'</td></tr>';
			$out .= '<tr><td style="border-top:1px solid #dddddd;" colspan="3"><div class="moreclickstatinfocontainer" style="display:none;padding-bottom:10px;">';
			$nomonthclicks = '<i>'.$langmessage[$addon_current_id]["Not any clicks on this month"].'!</i>';
			$section = "";
			if(isset($info['monthclicks'])){
				
				$montclicksum = 0;				
				$kuu = date('Y.m', $info['lastclick']);
				$month = date('Ym', $info['lastclick']);
				if($month < $ctimemonth)
					$_nomonthclicks = $nomonthclicks;
				else
					$_nomonthclicks = "";
				$section .= '<p style="text-align:left;margin:3px;font-size:12px">'.$_nomonthclicks.' <b>'.$kuu.' '.$langmessage[$addon_current_id]["Month Clicks"].' ('.$langmessage[$addon_current_id]["Clicks Count"].' - %montclicksum% )</b></p>';
				$section .= '<table style="width:inherit;">';
				$section .= '<tr>';
				$section .= '<td style="width:50px;padding:0">';
				$section .= '<div style="border:1px solid #cccccc;padding:1px;">'.$langmessage[$addon_current_id]["day"].'</div>';
				$section .= '<div style="border:1px solid #cccccc;padding:1px;">'.$langmessage[$addon_current_id]["clicks"].'</div>';
				$section .= '</td>';
				foreach ($info['monthclicks'] as $day => $dayclicks){

					$dy = date('Y', $dayclicks[0]);
					$dm = date('m', $dayclicks[0]);
					$section .= '<td style="padding:0">';
					$section .= '<div style="border:1px solid #cccccc;padding:1px;">'.$day.'</div>';
					$section .= '<div style="border:1px solid #cccccc;padding:1px;font-size:10px">';
					if(rifBBCloneAdmin::NoArchive())
						$section .= count($dayclicks);
					else
						$section .= ''.common::Link('Admin_BBC_Detailed_Stats', count($dayclicks), 'bbc_arch_year='.$dy.'&bbc_arch_month='.$dm.'&spyday='.$dy.$dm.$day.'&visitpage='.common::indexToTitle($pageindex).'&index='.$pageindex.'&title='.$info['linkname'].'&gpabox=1', 'name="gpabox" style="display:block;text-decoration:underline;text-align:center;" onmouseover="this.style.background=\'#fcf1be\';" onmouseout="this.style.background=\'\';"').'';
						
					$section .= '</div>';
					$section .= '</td>';

					$montclicksum = $montclicksum+count($dayclicks);
				}
				$section .= '<tr>';
				$section .= '</table>';				
			}else{
				$section .= '<p style="text-align:left;margin:3px;font-size:12px">'.$nomonthclicks.'</p>';
			}
			$out .= str_replace("%montclicksum%", $montclicksum,$section);
			$out .= '</div></td></tr>';			
		}

		$js = "$('.moreclickstatinfo').click(function(){
			var showcontainer = $(this).closest('tr').next('tr').find('.moreclickstatinfocontainer');
			showcontainer.slideToggle( 'fast' );
		});";		
		$out .= '</table>';
		if($popup){
			$out .= '<script>';
			$out .= $js;
			$out .= '</script>';
		}
		
		if(!$popup){
			$_out[$_clickstats_key] = $out;			
		}else
			$_out = $out;

		return $_out;
	}
	
	function GetClickTimes(){
		global $addonPathData, $langmessage, $addon_current_id;
		
		$y = $_REQUEST['bbc_arch_year'];
		$m = $_REQUEST['bbc_arch_month'];
		$d = $_REQUEST['spyday'];
		$page = $_REQUEST['visitpage'];
		$index = $_REQUEST['index'];
		$title = $_REQUEST['title'];
		
		$folder = $addonPathData.'/clickstats/';
		if( file_exists($addonPathData.'/archives/'.$y.'/'.$m.'/clickstats/'))
			$folder = $addonPathData.'/archives/'.$y.'/'.$m.'/clickstats/';
		
		if(file_exists($folder.$index.'.php'))
			include($folder.$index.'.php');
		
		$day = substr($d,-2);		
		$out = '<p><b>'.$page.' - '.$title.'</b> ('.$day.'.'.$m.'.'.$y.')<br>';
		$out .= $langmessage[$addon_current_id]["Filter times"].' ('.count($clickstats[$title]['monthclicks'][$day]).'): ';
		foreach($clickstats[$title]['monthclicks'][$day] as $times ){
			$out .= ' | <a class="clickstatstimelinks" data-time="'.date('Hi', $times).'">'.date('H:i:s', $times).'</a>';
		}
		$out .= ' | <a class="clickstatstimelinks" data-time="2355">'.$langmessage[$addon_current_id]["All times"].' </a> ';
		return $out.'</p>';
	}

	
	function _Detailed_ClickStats($folder=false){
		global $page, $addonPathData, $langmessage, $addon_current_id;
	
		if(!$folder)
			$folder = $addonPathData.'/clickstats/';
		if(isset($_REQUEST['bbc_arch_year']) && isset($_REQUEST['bbc_arch_month']))
			$folder = $addonPathData.'/archives/'.$_REQUEST['bbc_arch_year'].'/'.$_REQUEST['bbc_arch_month'].'/clickstats/';
	
		echo '<h3>'.$langmessage[$addon_current_id]["Click Counter Pages"].'</h3>';
		
		$sortpages = array();
		foreach (glob($folder."*.php") as $filename){
			
			$id = explode('/',$filename);
			$ids = explode('.', end($id));
			$pageindex = $ids[0];
			
			$sortpages = $sortpages+self::Detailed_ClickStats($pageindex, false);
		}
		//message($sortpages);
 		krsort($sortpages);
		foreach($sortpages as $printpages){
			echo $printpages;
		} 
		
		$js = "$('.moreclickstatinfo').click(function(){
			var showcontainer = $(this).closest('tr').next('tr').find('.moreclickstatinfocontainer');
			showcontainer.slideToggle( 'fast' );
		});";
		$page->jQueryCode .= $js;

	}
	
	function GetDay($files, $day, $row=1, $array=array(), $count=0){
		
		if(empty($files[$count]))
			return $array;
		
		include($files[$count]);
		
		if(isset($last["pages"]))
			$array['latestpages'] = $last["pages"];
		
		if(empty($last['traffic']))
			return $array;
		
		$fky = key($last['traffic']);
		$firstrow = date("Ymd", $last['traffic'][$fky]['time']);
		if(!isset($row) or $row=="")
			$row = 1;
		if($row != "firstrows"){
			$i = $row-1;
			$row = "lastrows";
		}
		
		
		foreach ($last['traffic'] as $a => $v ){
			$_day = date("Ymd", $v['time']);
			$lastrow = date("Ymd", $v['time']);
			
			if($day == $_day){
				if(isset($i)){
					$i= $i+1;
					$array[$i] = $last['traffic'][$a];
				}else
					$array[] = $last['traffic'][$a];
			}
		}
				
		if($row == "lastrows" && $lastrow == $day)
			$array = self::GetDay($files, $day, $i, $array, $count+1);
		if($row == "firstrows" && $firstrow == $day)
			$array = self::GetDay($files, $day, "firstrows", $array, $count+1);
		
		return $array;
	}
	
	function SortTraffic($a, $b){
		if($a['time'] < $b['time']){
			return -1;
		}else if($a['time'] > $b['time']){
			return 1;
		}
		return 0;
	}
	
	function ShowRobots($m="&"){
		if(isset($_REQUEST["norobots"]))
			return $m.'norobots=1';
		return "";
	}
	
 	static function FilterDataHelper($data, $key, $collect){
		if(isset($data[$key])){
			if(array_key_exists($data[$key], $collect))
				$count = $collect[$data[$key]]+1;
			else
				$count = 1;
			$collect[$data[$key]] = $count;
		}
		return $collect;
	}
	static function FilterData($data, $case="", $collect=array(), $pages=array(), $pagetitle=false){
		
		  switch ($case) {
			case "visitpage":
				$page = array();
				//views - 1522087738|39|1 time-page-nr
				foreach($data['views'] as $_page){
					$p = explode("|", $_page);
					if(!$pagetitle){
						if(array_key_exists($p[1], $pages))
							$page[] = $pages[$p[1]];
					}else{
						if($pagetitle == $pages[$p[1]]){
							$page[] = $pages[$p[1]];
							break;
						}
					}
				}
				
				return $page;
			case "pages":
				//views - 1522087738|39|1 time-page-nr
				if(!isset($data['views']))
					return $collect;
				
				foreach($data['views'] as $page){
					$p = explode("|", $page);
					if(array_key_exists($p[1], $pages))
						$title = $pages[$p[1]];
					else
						return $collect;
					
					if(array_key_exists($title, $collect))
						$count = $collect[$title]+1;
					else
						$count = 1;
					
					$collect[$title] = $count;
				}
				
				return $collect; 				
			case "browser":

				return self::FilterDataHelper($data, 'browser', $collect);
			case "os":
			
				return self::FilterDataHelper($data, 'os', $collect);
			case "ip":

				return self::FilterDataHelper($data, 'ip', $collect); 
			case "robot":

				return self::FilterDataHelper($data, 'robot', $collect);
			case "ext":

				return self::FilterDataHelper($data, 'ext', $collect); 
		  }
	}
	
	function AllMonthArchiveFiltering(){
		
		$rows = self::AllMonthArchive();
		$filter=array();
		if(empty($rows))
			return $filter;		
				
		$filter['pages']=$filter['robot']=$filter['browser']=$filter['os']=$filter['ip']=$filter['ext']= array();		
		foreach($rows['traffic'] as $nr => $data){
			if(isset($data['robot']) && isset($_REQUEST['norobots']))
				continue;
			$filter['pages'] = self::FilterData($data, "pages", $filter['pages'], $rows['pages']);
			$filter['robot'] = self::FilterData($data, "robot", $filter['robot']);	 
			$filter['browser'] = self::FilterData($data, "browser", $filter['browser']);
			$filter['os'] = self::FilterData($data, "os", $filter['os']);
			$filter['ip'] = self::FilterData($data, "ip", $filter['ip']);
			$filter['ext'] = self::FilterData($data, "ext", $filter['ext']);
		}
		foreach($filter as $k=>$v)
			arsort($filter[$k]);
			
		return $filter;
	}	
		
	function ShowArchivedDetailed($dir='counter'){
		global $addonPathData, $BBC_TIME_OFFSET;
	
		$year = $month = $file = false;
		
		if(!empty($_REQUEST['bbc_arch_year']))
			$year = $_REQUEST['bbc_arch_year'];
		if(!empty($_REQUEST['bbc_arch_month']))
			$month = $_REQUEST['bbc_arch_month'];
		if(!empty($_REQUEST['bbc_arch_files']))
			$file = $_REQUEST['bbc_arch_files'];
		
		$folder = $addonPathData.'/archives/';
		$array = array();
				
		if(!$year)
			return false;
		
		if(!file_exists($folder.$year))
			return false;
			
		if(!$dir)
			return false;
		
		$ctime = time() + ($BBC_TIME_OFFSET * 60);		
			
		if($month && file_exists($folder.$year.'/'.$month)){
				
			if(!file_exists($folder.$year.'/'.$month.'/'.$dir))
				return false;
			
			include($folder.$year.'/'.$month.'/'.$dir.'/pages.inc');
			$array['pages'] = $pages;
			
			if($file && file_exists($folder.$year.'/'.$month.'/'.$dir.'/'.$file.'.php')){
					
				//File action
				include($folder.$year.'/'.$month.'/'.$dir.'/'.$file.'.php');
				$array['traffic'] = $last['traffic'];
	
			}else{
				//Month action ...	for each files
				if(isset($_REQUEST["spyday"])){
					$firstfiles = array();
					$lastfiles = array();
					$file = "*";				
					foreach (glob($folder.$year.'/'.$month.'/'.$dir.'/'.$file.'.php') as $filename){
						$id = explode('/',$filename);
						$ids = explode('.', end($id));
						$time = str_replace("last_", "", $ids[0]);

						$day = date("Ymd", $time);
	
						if($day <= $_REQUEST["spyday"]){
							$firstfiles[] = $filename;
						}else{
							$lastfiles[] = $filename;
						}					
					}
									
					if(date("Ym", $ctime) == $year.$month)
						$lastfiles[] = $addonPathData.'/counter/last.php';

					$firstrows = self::GetDay(array_reverse($firstfiles), $_REQUEST["spyday"], "firstrows");
					$lastrows = self::GetDay($lastfiles, $_REQUEST["spyday"], count($firstrows));
					$dayarray =  $firstrows + $lastrows;
					if(isset($dayarray['latestpages'])){
						$array['pages'] = $dayarray['latestpages'];
						unset($dayarray['latestpages']);
					}
					usort($dayarray, "self::SortTraffic");
					$array['traffic'] = $dayarray;
					
				}

				if($file == "all"){
					$requests = array('robot','browser','os','ip','ext');
					foreach($requests as $req){
						if(isset($_REQUEST[$req])){
							$rows = self::AllMonthArchive();
							foreach ($rows['traffic'] as $nr => $data){
								if(isset($data[$req]) && $_REQUEST[$req] == $data[$req])
									$array['traffic'][] = $data;
							}
						}
					}
					if(isset($_REQUEST["pages"])){
						$rows = self::AllMonthArchive();
						foreach ($rows['traffic'] as $nr => $data){
							$vpages = rifBBCloneAdmin::FilterData($data, "visitpage", "", $rows['pages'], $_REQUEST["pages"]);
							if(in_array($_REQUEST["pages"], $vpages))
								$array['traffic'][] = $data;
						}
					}
				}
				
			}
			
		}else{				
			//Year action ... for each month foreach (glob($folder.$year as $monthdir){}
			if(isset($_REQUEST["spyday"])){
				include($addonPathData.'/counter/last.php');
				foreach($last['traffic'] as $ti => $rows){
					if($_REQUEST["spyday"] == date("Ymd", $rows['time']))
						$last['traffic'][] = $rows;
				}
				$array = $last;
			}
			
		}
		
		if(empty($array))
			return false;
		
		return $array;
	}
	
 	function AllMonthArchiveFiles(){
		global $addonPathData, $BBC_TIME_OFFSET;
	
		$all_files = array();
	
		if(!isset($_REQUEST['bbc_arch_files']))
			return $all_files;
		
		if($_REQUEST['bbc_arch_files'] != "all")
			return $all_files;
		
		if(!isset($_REQUEST['bbc_arch_year']) && !isset($_REQUEST['bbc_arch_month']))
			return $all_files;
		
		$folder = $addonPathData.'/archives/'.$_REQUEST['bbc_arch_year'].'/'.$_REQUEST['bbc_arch_month'].'/counter/';
		
		$ctime = time() + ($BBC_TIME_OFFSET * 60);
		if(date("Ym", $ctime) == $_REQUEST['bbc_arch_year'].$_REQUEST['bbc_arch_month'])
			$all_files['last'][] = $addonPathData.'/counter/last.php';
		else
			$all_files['pages'] = $folder.'pages.inc';
		
		foreach (glob($folder."*.php") as $filename)
			$all_files['last'][] = $filename;
		
		return $all_files;
	}
	
	function AllMonthArchive(){
		global $addonPathData;

		$all_lasts = array();
		$all_files = self::AllMonthArchiveFiles();

		if(empty($all_files))
			return $all_lasts;
	
		if(isset($all_files['pages'])){
			include $all_files['pages'];				
			$all_lasts['pages'] = $pages;
		}
		
		foreach ($all_files['last'] as $file){
			include $file;
			
			if($file == $addonPathData.'/counter/last.php'){
				$all_lasts['pages'] = $last['pages'];
				
				unset($last['pages']);
			}
		
			//all monthly traffic manipulation			
			foreach($last['traffic'] as $nr => $data){				
				$all_lasts['traffic'][] = $data;
			}
	
		}		
				
		return $all_lasts;
	} 
		
	
	function GetArhives($dir='counter'){
		global $addonPathData;
		
		$arhive = $addonPathData.'/archives/';
		if(!file_exists($arhive))
			return false;
		
		$out = array();
		
		$f = scandir($arhive);
		if(empty($f))
			return false;

		foreach($f as $y){
			if (is_numeric($y) && is_dir($arhive.$y) )
				$years[] = $y;
		}
		
		if(!isset($years))
			return false;
	
		foreach($years as $year){
			$fm = scandir($arhive.$year);
			if(empty($fm))
				continue;
						
			foreach($fm as $month){
				if (!is_numeric($month) or !is_dir($arhive.$year.'/'.$month) )
					continue;
				if (!file_exists($arhive.$year.'/'.$month.'/'.$dir))
					continue;
				
				$ff = scandir($arhive.$year.'/'.$month.'/'.$dir);
				if(empty($ff))
					continue;
				
				$_files = array();
				foreach($ff as $files){
					
					$file = explode(".", $files);
					if(!isset($file[1]))
						continue;
					if($file[1] !== "php")
						continue;
				
					$_files[] = $file[0];					
				}
				
				if(!empty($_files)){
					$out[$year][$month] = $_files;
				}								
			}
		}
		
		if(empty($out))
			return false;
			
		return $out;		
	}
	
	function IncludeLibs($opt){
		global $addonPathCode, $addonRelativeCode, $langmessage, $addon_current_id;
		
		$out = array();
		if(trim($opt)=="")
			return $out;
		
		if(file_exists($addonPathCode.'/lib/'.$opt.'.php'))
			include($addonPathCode.'/lib/'.$opt.'.php');		
		
		if($opt=='os' && isset($os)){			
			$out = $os;
		}
		if($opt=='browser'&& isset($browser)){
			$out = $browser;
		}
		if($opt=='robot'&& isset($robot)){
			$out = $robot;
		}
		if($opt=='ext'){
			$out['ext'] = $langmessage[$addon_current_id]["extensions"];
		}
		
		if(!empty($out)){
			$out['imagerel'] =  $addonRelativeCode.'/images/'.$opt.'/';
			$out['imageobs'] =  $addonPathCode.'/images/'.$opt.'/';
		}	
		return $out;
	}
	
	function ImagesLabels($lib, $type){
		global $langmessage,$addon_current_id;
		
			$title = $image = false;
			
			if(empty($lib))
				return array($title, $image);
			
			if(isset($lib['ext'])){
				$image = $lib['imagerel']."other.png";
				if(file_exists($lib['imageobs'].$type.".png"))
					$image = $lib['imagerel'].$type.".png";
				$title = $type;
				if (isset($lib['ext'][$type])) 
					$title = $lib['ext'][$type];
			}else{
				if(file_exists($lib['imageobs'].$lib[$type]['icon'].".png") && isset($lib[$type]))
					$image = $lib['imagerel'].$lib[$type]['icon'].".png";
				$title = $lib[$type]['title'];
				$title = str_replace("other", $langmessage[$addon_current_id]["translation"]['misc_other'], $title);
			}
			
			return array($title, $image);
	}
	
	function AllMonthOptions(){
		global $addonRelativeCode, $addonPathCode, $langmessage, $addon_current_id;
		
		$translation = $langmessage[$addon_current_id]["translation"];
		$fields_title = array(
			"browser" => $translation['dstat_browser'],
			"dns" => $translation['dstat_dns'],
			"ext" => $translation['dstat_extension'],
			"id" => $translation['dstat_id'],
			"ip" => $translation['dstat_ip'],
			"os" => $translation['dstat_os'],
			"pages" => $translation['dstat_pages'],
			"robot" => $translation['dstat_robots'],
			"prx_ip" => $translation['dstat_prx'],
			"referer" => $translation['dstat_from'],
			"search" => $translation['dstat_search'],
			"time" => $translation['dstat_time'],
			"visits" => $translation['dstat_visits'],
		);
		
		$options = self::AllMonthArchiveFiltering();
		
		if(empty($options ))
			return "";
		
		$MENU = "";
		$OUT = "";
		$not_selected = "display:block;";
		foreach($options as $opt => $selects){
			$show = "display:none;";
			$bg = "";			
			
			if(isset($_REQUEST[$opt])){
				//$show = "display:block;";
				$bg = "background:#ffefbf;color:black;text-decoration:underline;";
				$not_selected = "display:none;";
			}
			
			$MENU .= '<a data-opt-box="'.$opt.'" style="'.$bg.'display:inline-block;">&nbsp;'.ucfirst($fields_title[$opt]).'&nbsp;</a>| ';
			$OUT .= '<div id="'.$opt.'-box" style="'.$show.'" class="opt-box">';
			$col = count($selects);
			$col = ($col/4);			
			$col = round($col, 0, PHP_ROUND_HALF_UP)+1;
			
			$lib = self::IncludeLibs($opt);		
			
			$i = 1;
			foreach($selects as $sel => $count){			

				if($i == 1 ){
					$OUT .= '<ul style="vertical-align:top;padding:3px;margin:0 2px 0 0;display:inline-block;width:24.5%;border:1px solid #ececfb;">';
				}
								
				$titleImage = self::ImagesLabels($lib, $sel);
				
				$img='';				
				if($titleImage[1]){	
					$img='<img src="'.$titleImage[1].'"> ';	
				}

				$countnum = ' <b style="font-size:12px;">('.$count.')</b>';
				if($count < 2)
					$countnum = "";

				$title = str_replace(array("_", "/"), array(" ", " /"), $sel);
				if($titleImage[0])
					$title = $titleImage[0];
				
				$selmark = "background:#ececfb;";
				$q = "&".$opt."=".$sel;
				if(isset($_REQUEST[$opt]) && $_REQUEST[$opt] == $sel)
					$selmark = "background:#ffefbf;color:black;";
				
				$OUT .= '<li style="'.$selmark.'min-height:22px;padding:2px;margin-bottom:2px;">'.$img;
				$OUT .= common::Link('Admin_BBC_Detailed_Stats', $title, 'bbc_arch_year='.$_REQUEST['bbc_arch_year'].'&bbc_arch_month='.$_REQUEST['bbc_arch_month'].'&bbc_arch_files=all'.self::ShowRobots().$q, 'style="'.$selmark.'"');
				$OUT .= $countnum.' </li>';

				$i++;
				if($i > $col){
					$i = 1;
					$OUT .= '</ul>';
				}
			}
			
			$OUT .= '</div>';
		}
		
		$OUT .= '<div style="'.$not_selected.'text-align:center;color:#9999ff;font-weight:bold;" class="opt-box">'.$langmessage[$addon_current_id]['Please select an option'].'</div>';			
		return '<div class="gpsubmit" style="white-space:normal;width:100%;text-align:center;margin-bottom:3px;" id="allinmonth-optionselector" >'.$langmessage[$addon_current_id]['Options'].': |'.$MENU.'</div>'.$OUT;
	}
	
	function GetAllArhiveRowsTimes(){
		
		$all_lasts = array();
		$all_files = self::AllMonthArchiveFiles();
		
		if(empty($all_files))
			return $all_lasts;

		foreach ($all_files['last'] as $file){
			include $file;
			foreach($last['traffic'] as $array){
				if(isset($array['robot']) && isset($_REQUEST['norobots']))
					continue;
				$times[] =	$array["time"];
			}				
			unset($last['traffic']);
		}

		sort($times);		
		return $times;
	}
	
  	function MakeAllArhiveTimeArray(){
		global $access, $addonPathCode;
		
		if(!isset($_REQUEST['bbc_arch_day']))
			return;
		
		$access["time"] = array();
				
		$times = self::GetAllArhiveRowsTimes();
		
		$selecttime = $_REQUEST['bbc_arch_day'];
		include $addonPathCode.'/lib/timecalc.php';
		$last_time = 0;
		
		foreach($times as $time){
			if($last_time != 0 && $last_time > $selecttime)
				break;	
			bbc_update_time_stat($time, $last_time);			
			$last_time = $time;
		}
			
		return $access["time"];
	}
	
	function DayListInMonth($year, $month) {
		global $BBC_TIME_OFFSET;
		$start_date = "01-".$month."-".$year;
		$start_time = strtotime($start_date);
		$end_time = strtotime("+1 month", $start_time);

		$list = "";
		$now = time() + ($BBC_TIME_OFFSET * 60);
		$nowday = date('Ymd', $now);
		for($i=$start_time; $i<$end_time; $i+=86400){
			if(date('Ymd', $i) > $nowday)
				break;
			$selday = "";
			if(isset($_REQUEST['bbc_arch_day']) && $_REQUEST['bbc_arch_day'] == $i)
				$selday = "color:#006600;font-weight:bold;text-decoration:underline;";
			$list .= ' <i style="display:inline-block">'.common::Link('Admin_BBC_Time_Stats', date('d', $i), 'bbc_arch_year='.$year.'&bbc_arch_month='.$month.'&bbc_arch_day='.$i.'&bbc_arch_files=all'.self::ShowRobots(), 'style="'.$selday.'"')."<b> | </b></i>";
		}
		
		return $list;
	}
	
	function ArhciveForm($archdir = "counter", $timestats=""){
		global $langmessage, $addon_current_id;
			
		if(isset($_REQUEST['archdir']) && $_REQUEST['archdir'] != "")
			$archdir = $_REQUEST['archdir'];
		
		$archiveselect = array_reverse(self::GetArhives($archdir), true);

		if($archiveselect){
			echo '<div id="bbc_archive_search" style=" border-radius:5px;padding:5px;border:1px solid #999999;margin:10px 0 10px 0;">';
			echo '<b>'.$langmessage[$addon_current_id]['Archive'].': </b>';
			echo '<select class="gpselect" style="padding-top:2px;padding-bottom:3px;" id="bbc_arch_year" data-archdir="'.$archdir.'" data-timestats="'.$timestats.'" name="bbc_arch_year">';

			$getyear = key($archiveselect);
			foreach ($archiveselect as $Y => $M){
				$selyear="";
				if(!empty($_REQUEST['bbc_arch_year']) && $_REQUEST['bbc_arch_year'] == $Y){
					$getyear = $Y;
					$selyear = " selected";
				}				
				echo '<option value="'.$Y.'"'.$selyear.'>'.$Y.'</option>';
			}
			echo '</select>';

			if(isset($getyear)){
				$archiveselect[$getyear] = array_reverse($archiveselect[$getyear], true);
				$getmonth = key($archiveselect[$getyear]);
				echo '<select style="padding-top:2px;padding-bottom:3px;" class="gpselect" id="bbc_arch_month" data-archdir="'.$archdir.'" data-timestats="'.$timestats.'" name="bbc_arch_month">';
				foreach ($archiveselect[$getyear] as $month => $f){
					$selmonth="";
					if(!empty($_REQUEST['bbc_arch_month']) && $_REQUEST['bbc_arch_month'] == $month){
						$getmonth = $month;
						$selmonth = " selected";
					}								
					echo '<option value="'.$month.'"'.$selmonth.'>'.$month.'</option>';
				}
				echo '</select>';
			}
		
			if(isset($getyear) && isset($getmonth) && $archdir=="counter"){
				echo '<div name="bbc_arch_file" style="margin-top:5px;">';
				
				if($timestats == ""){
					
					foreach ($archiveselect[$getyear][$getmonth] as $file){
						$filetitle = explode("_", $file);
						$selfile="";
					
						$_day = '<b style="color:#356297;font-size:12px;">'.date('d', end($filetitle)).'</b>';
						if(!empty($_REQUEST['bbc_arch_files']) && $_REQUEST['bbc_arch_files'] == $file){
							$selfile="color:#006600;font-weight:bold;text-decoration:underline;";
							$_day = '<b style="color:#006600;font-size:inherit;">'.date('d', end($filetitle)).'</b>';
						}
						
						echo ' <i style="display:inline-block">'.$langmessage[$addon_current_id]['To'].' - '.common::Link('Admin_BBC_Detailed_Stats', $_day.' '. date('(H:i)', end($filetitle)), 'bbc_arch_year='.$getyear.'&bbc_arch_month='.$getmonth.'&bbc_arch_files='.$file.self::ShowRobots(), 'style="'.$selfile.'"')."<b> | </b></i>";
					}
					$selall="";
					if(!empty($_REQUEST['bbc_arch_files']) && $_REQUEST['bbc_arch_files'] == "all")
						$selall="color:#006600;font-weight:bold;text-decoration:underline;";
					echo ' <i style="display:inline-block;font-weight:bold">'.common::Link('Admin_BBC_Detailed_Stats', $langmessage[$addon_current_id]['All in this month'], 'bbc_arch_year='.$getyear.'&bbc_arch_month='.$getmonth.'&bbc_arch_files=all'.self::ShowRobots(), 'style="'.$selall.'"')."<b> | </b></i>";

				}else{
					
					echo self::DayListInMonth($getyear, $getmonth);
					
				}
				
				echo '</div>';
			}else{
				echo '<span class="gpsubmit">'.common::Link('Admin_BBC_Detailed_Stats', "OK", 'cmd=bbc_clickcouterstats&bbc_arch_year='.$getyear.'&bbc_arch_month='.$getmonth.'&archdir=clickstats', 'style="font-weight:bold;font-size:12px;"')."</span>";
			}
								
			//	echo '<span class="gpsubmit">'.common::Link('Admin_BBC_Time_Stats', "OK", 'bbc_arch_year='.$getyear.'&bbc_arch_month='.$getmonth.'&bbc_arch_files=all', 'style="font-weight:bold;font-size:12px;"')."</span>";
			
			if(!empty($_REQUEST['bbc_arch_files']) && $_REQUEST['bbc_arch_files'] == "all" && $timestats == ""){
				echo '<div id="allinmonth-options" style="border-radius:5px;border:2px solid #c8c5f5;margin:10px 0 5px 0;padding:5px;">';
				
				echo self::AllMonthOptions();
				
				echo '</div>';
			}
			echo '</div>';
		}
	}
	
	function timezones() {
		$timezones = array();
		foreach (DateTimeZone::listIdentifiers() as $timezone) {
			$datetime = new \DateTime('now', new DateTimeZone($timezone));
			$timezones[] = array(
				'sort' => str_replace(':', '', $datetime->format('P')),
				'offset' => $datetime->format('P'),
				'offsetminits' => round($datetime->format('Z')/+60,2),
				'name' => str_replace('_', ' ', implode(', ', explode('/', $timezone))),
				'timezone' => $timezone,
			);		
		}
		usort($timezones, function($a, $b) {
			return $a['sort'] - $b['sort'] ?: strcmp($a['name'], $b['name']);
		});
		return $timezones;
	}
	
	function timezonesFilterArray(){
		$out = array();
		$n = false;
		foreach (self::timezones() as $timezone) {
			if($n !== false && $n == $timezone['offsetminits'])
				continue;
			$out[$timezone['offsetminits']] = 'UTC '.$timezone['offset'].' ('.$timezone['offsetminits'].' min.)';
			$n = $timezone['offsetminits'];
		}
		return $out;
	}
	
	static function NoArchive(){
		global $addonPathData;
		
		if(file_exists($addonPathData.'/archives'))
			return false;
		
		return true;
	}
	
	function RemAllArchives($path) { 
		if (empty($path)) { 
			return false;
		}
		return is_file($path) ?
				@unlink($path) :
				array_map(array('rifBBCloneAdmin', 'RemAllArchives'), glob($path.'/*')) == @rmdir($path);
	}

}
	

class ShowGlobals extends rifBBCloneAdmin{
	
	public function __construct() {
		global $addonPathCode;
		global $langmessage, $addon_current_id;
		global $BBC_ACCESS_FILE;
		
		self::get_config();
				
		echo self::admn_menu(array(1,0,0,0,0));
		$translation = $langmessage[$addon_current_id]["translation"];
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Global");}
		$start = self::start_time();
		
		require_once($BBC_ACCESS_FILE);
		
		$BBC_HTML = new BBC_HTML;

		include_once("show_global.php");		
		self::end_time($start);
	}
	
}


class ShowViews extends rifBBCloneAdmin{
	
	public function __construct() {
		global $addonPathCode, $addonRelativeCode;
		global $langmessage, $addon_current_id;
		global $BBC_LAST_FILE;
		
		self::get_config();
		
		if(!isset($_REQUEST["gpabox"]))
			echo self::admn_menu();
		
		$translation = $langmessage[$addon_current_id]["translation"];
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Views");}
		$start =self::start_time();
				
		$archive = rifBBCloneAdmin::ShowArchivedDetailed();
		if($archive){			
			$GLOBALS['last'] = $archive;				
		}else{
			require_once($BBC_LAST_FILE);		
		}
		
		$BBC_HTML = new BBC_HTML;
		
		include_once("show_views.php");		
		self::end_time($start);
	}
	
}


class ShowTime extends rifBBCloneAdmin{	

	public function __construct() {
		global $page, $addonPathCode, $addonPathData, $addonRelativeCode;
		global $langmessage, $addon_current_id;
		global $BBC_ACCESS_FILE;

		self::get_config();
		
		$usearchive = true;
		if(rifBBCloneAdmin::NoArchive()) 
			$usearchive = false;
		
		
		$archdir = "counter";
		
		if(isset($_GET['cmd'])){
			if($_GET['cmd'] == "bbc_ajaxarchiveform"){
				self::ArhciveForm($archdir, "yes");
				exit;
			}				
		}
		
		$page->head_js[] = $addonRelativeCode.'/admin.js';
		
		echo self::admn_menu(array(0,0,1,0,0));
		
		$translation = $langmessage[$addon_current_id]["translation"];
		
		$robotstitle = $langmessage[$addon_current_id]["Show Robots"];
		$q = "";
		foreach($_REQUEST as $k => $v ){
			if($k == "norobots")
				continue;
			$q .= "&".$k."=".$v;
		}
		if(!isset($_REQUEST["norobots"])){
			$robotstitle = $langmessage[$addon_current_id]["Hide Robots"];
			$q .= "&norobots=1";
		}
		
		$active = 'style="color:#006600;font-weight:bold;"';
		if(isset($_REQUEST['bbc_arch_year']) && isset($_REQUEST['bbc_arch_month']))
			$active = "";
		if($usearchive)
			echo common::Link('Admin_BBC_Time_Stats',$langmessage[$addon_current_id]["Last Statistic"], self::ShowRobots(), $active)." |  ";
		echo common::Link('Admin_BBC_Time_Stats', $robotstitle, $q);

		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Time");}
			$start =self::start_time();
		
		$archive = false;
		if($usearchive){
			self::ArhciveForm($archdir, "yes");
			$archive = rifBBCloneAdmin::MakeAllArhiveTimeArray();
		}
		
		if($archive){		
			$GLOBALS['access']['time'] = $archive;				
		}else{				
			require_once($BBC_ACCESS_FILE);				
		}		
		
		$BBC_HTML = new BBC_HTML;
		
		include_once("show_time.php");		
		self::end_time($start);
	}
	
}


class ShowDetailed extends rifBBCloneAdmin{	

	public function __construct() {
		global $page, $addonPathCode, $addonPathData, $addonRelativeCode;
		global $langmessage, $addon_current_id;
		global $BBC_LAST_FILE, $BBC_USE_ARCHIVE;
		
		$clickcounter = false;
		$archdir = "counter";
		self::get_config();
		
		$usearchive = true;
		if(rifBBCloneAdmin::NoArchive())
			$usearchive = false;
		
		if(isset($_GET['cmd'])){
			if($_GET['cmd'] == "bbc_ajaxarchiveform"){
				self::ArhciveForm();
				exit;
			}
			if($_GET['cmd'] == "bbc_clickcouterstats"){
				$clickcounter = true;
				$archdir = "clickstats";
			}				
		}

		
		
		$page->head_js[] = $addonRelativeCode.'/admin.js';
		
		if(!isset($_REQUEST["gpabox"]))
			echo self::admn_menu(array(0,1,0,0,0));
		$translation = $langmessage[$addon_current_id]["translation"];
		
		$active = 'style="color:#006600;font-weight:bold;"';
		if(isset($_REQUEST['bbc_arch_year']) && isset($_REQUEST['bbc_arch_month']))
			$active = "";

		if(!$clickcounter){
				
			$robotstitle = $langmessage[$addon_current_id]["Show Robots"];
			$q = "";
			foreach($_REQUEST as $k => $v ){
				if($k == "norobots")
					continue;
				$q .= "&".$k."=".$v;
			}
			if(!isset($_REQUEST["norobots"])){
				$robotstitle = $langmessage[$addon_current_id]["Hide Robots"];
				$q .= "&norobots=1";
			}
			if(!isset($_REQUEST["gpabox"])){
				if($usearchive)
					echo common::Link('Admin_BBC_Detailed_Stats',$langmessage[$addon_current_id]["Last Statistic"], self::ShowRobots(), $active)." |  ";
				echo '<b>'.common::Link('Admin_BBC_Detailed_Stats',$langmessage[$addon_current_id]["Click Counter Statistic"], "cmd=bbc_clickcouterstats".self::ShowRobots()).'</b>';
				echo ' | '.common::Link('Admin_BBC_Detailed_Stats', $robotstitle, $q);
			}else{
				echo ' | '.common::Link('Admin_BBC_Detailed_Stats', $robotstitle, $q.'gpabox=1', 'name="gpabox"');
				echo ' | '.self::GetClickTimes();
			}				
		}else{
			
			if(!isset($_REQUEST["gpabox"])){
				if($usearchive)
					echo common::Link('Admin_BBC_Detailed_Stats',$langmessage[$addon_current_id]["Last Statistic"], "cmd=bbc_clickcouterstats".self::ShowRobots(), $active)." |  ";
				echo '<b>'.common::Link('Admin_BBC_Detailed_Stats',$langmessage[$addon_current_id]["Page Visits Statistic"], self::ShowRobots()).'</b>';
			}
		}
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Detailed");}
			$start = self::start_time();		
		
		if(!isset($_REQUEST["gpabox"]) && $usearchive){
			self::ArhciveForm($archdir);
		}else{
			
		}

		if($clickcounter){			
			self::_Detailed_ClickStats();			
		}else{
			
			$archive = rifBBCloneAdmin::ShowArchivedDetailed();
			if($archive){
				$GLOBALS['last'] = $archive;				
			}else{				
				require_once($BBC_LAST_FILE);				
			}	

			$BBC_HTML = new BBC_HTML;
			include_once("show_detailed.php");
			
		}
		
		self::end_time($start);
	}
	
}


class ShowConfig extends rifBBCloneAdmin{
	
	public function __construct() {
		global $addonPathCode, $addonPathData;
		global $langmessage, $addon_current_id;
		global $BBC_ACCESS_FILE;
		
		$start = self::start_time();
		
		$DefaultConf = gpFiles::Get( $addonPathCode.'/conf/config.php', 'bbc_config');
		$config = gpFiles::Get( $addonPathData.'/config.php', 'bbc_config');

		$killstats = false;	
		$remarchive = false;
		
		if(isset($_POST['cmd']) && $_POST['cmd'] == 'bbc_saveconfig'){
			
			//EREASE ALL STATS		
			if(isset($_POST['config']['BBC_KILL_STATS'])){
				$killstats = true;
				unset($_POST['config']['BBC_PURGE_SINGLE']);
				message($langmessage[$addon_current_id]['Statistics have been reset']);
			}
			//EREASE ALL ARCHIVES
			if(!isset($_POST['config']['BBC_USE_ARCHIVE'])){
				$remarchive = true;
			}
			//
			
			foreach($DefaultConf as $key => $val ){
				
				if(!isset($_POST['config'][$key])){
					$_POST['config'][$key] = "";
				}

				$config[$key] = $_POST['config'][$key];
		
				if(isset($_POST['defconfig'][$key])){					
					$config[$key] = $val;
				}
					
			}
			
			if( gpFiles::SaveArray($addonPathData.'/config.php', 'bbc_config', $config)){
				if($remarchive && file_exists($addonPathData.'/archives')){					
					self::RemAllArchives($addonPathData.'/archives');
					message($langmessage[$addon_current_id]['The whole archive has been deleted']); 
				}
				message($langmessage["SAVED"]);
			}else
				message("Error");
		}

		self::get_config();
		
		echo self::admn_menu(array(0,0,0,1,0));				
		$translation = $langmessage[$addon_current_id]["translation"];
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Config");}	
		
		//EREASE ALL STATS
		if($killstats){
			global $BBC_LIB_PATH, $BBC_KILL_STATS, $BBC_CACHE_PATH, $BBC_ACCESS_FILE, $BBC_LAST_FILE, $BBC_DEBUG, $BBC_LOCK;
		
			//erease clickstats also
			if(file_exists($addonPathData.'/clickstats')){
				foreach(glob($addonPathData.'/clickstats/'."*.php") as $filename)
					unlink($filename);				
			}
			
			if (!defined("_MARK_PAGE")) 
				define("_MARK_PAGE", "1");
	
			require_once($BBC_LIB_PATH."io.php");
			require_once($BBC_LIB_PATH."marker.php");
			
			$BBC_KILL_STATS = 1;
			$BBC_DEBUG = "";
			include($addonPathCode."/mark_page.php");
			
			file_put_contents($BBC_ACCESS_FILE, "<?php\nglobal \$access;\n\$access =\n array();\n?>");
			file_put_contents($BBC_LAST_FILE, "<?php\nglobal \$last;\n\$last =\n array();\n?>");
		}
		//		

		require_once($BBC_ACCESS_FILE);
		
		$BBC_HTML = new BBC_HTML;
		
		include_once("show_config.php");
		
		self::end_time($start);		
	}	
}

class OnlineGadget extends rifBBCloneAdmin{
	
	public function __construct() {
		global $addonPathCode, $addonPathData;
		global $langmessage, $addon_current_id, $addonFolderName;
		
		self::get_config();
		
		//Save CSS
		if(isset($_POST['bbc_OnlineCounter_CSS']))
			file_put_contents($addonPathData.'/bbc_online_gadget.css', $_POST['bbc_OnlineCounter_CSS']);
		
		If(file_exists($addonPathData.'/bbc_online_gadget.css'))
			$css = file_get_contents($addonPathData.'/bbc_online_gadget.css', true);
		else
			$css = file_get_contents($addonPathCode.'/bbc_online_gadget.css', true);
		
		echo self::admn_menu(array(0,0,0,0,1));
		$translation = $langmessage[$addon_current_id];
		
		echo '<p><b>'.$translation["The widget that shows the current visitors on the page"].'</b>';
		echo '<br>'.$translation["If you want to add a gadget to a page template"];
		echo '</p>';
		echo '<hr>';
		echo '<p>'.str_replace(array('{count-visitors}', '{count-robots}'), array('<i style="color:#d90036">{count-visitors}</i>', '<i style="color:#d90036">{count-robots}</i>'), $translation["Here you can change the text of the widget"]).'</p>';
		echo common::Link('Admin_Theme_Content',$translation["Edit Gadget Text"],'cmd=addontext&addon='.urlencode($addonFolderName),' title="'.urlencode($langmessage['editable_text']).'" name="gpabox" class="gpsubmit" ');
		echo '<hr>';
		echo '<p>'.$translation["CSS style for gadget"].':</p>';
		echo '<form action="'.common::GetUrl('Admin_BBC_OnlineGadget').'" method="post">';
		//echo '<input type="hidden" name="cmd" value="bbc_saveconfig" />';
		echo '<textarea name="bbc_OnlineCounter_CSS" rows="20" cols="50" style="width:100%">';
		echo $css;
		echo '</textarea>';
		echo '<input type="submit" name="" value="'.$langmessage['save'].'" class="gpsubmit">';
		echo '</form>'; 
		
	}
}
	


