<?php
defined('is_running') or die('Not an entry point...');

gpPlugin::Incl('COMMON.php');

class rifBBClone extends rifBBCloneCommon {
	
	static function HtmlHead() {
		global $page, $ml_object, $dirPrefix, $addonFolderName;
		global $addonPathCode, $addonPathData, $addonRelativeCode;
		
		$g = gpFiles::Get( $addonPathData.'/config.php', 'bbc_config');
		if(isset($g['BBC_KILL_STATS']) && $g['BBC_KILL_STATS'] == 1)
			return;
	
		//online visitor css
		If(file_exists($addonPathData.'/bbc_online_gadget.css'))
			$page->css_user[] = $dirPrefix.'/data/_addondata/'.$addonFolderName.'/bbc_online_gadget.css';
		else
			$page->css_user[] = $addonRelativeCode.'/bbc_online_gadget.css';

		// do not count admins visits
		if(common::loggedIn()){
			
			self::CopyFiles();
			
			global $BBC_LOADTIME,$BBC_LANGUAGE;
			self::ConfigGlobals();
		
			if (!empty($BBC_LOADTIME) && $page->pagetype != 'admin_display')				
				message("<div class=\"loadtime\">".self::AdminTextTranslates('You can see statistic loadtime if you loged out.')."</div>\n");
							
			return;
							
		}
				
		//TYPESETTER PAGE LABELS//$page->label//$page->TitleInfo['label']		
		if(!defined("_BBC_PAGE_NAME"))
			define("_BBC_PAGE_NAME", $page->title);
		
		// START Time Measuring, load-time of the page (see config)
		$start = self::start_time();
		
		require_once($addonPathCode."/constants.php");
		self::ConstantGlobals();		

		if (!defined("_MARK_PAGE")) 
			define("_MARK_PAGE", "1");
	
		require_once($BBC_LIB_PATH."io.php");
		require_once($BBC_LIB_PATH."marker.php");

		self::ConfigGlobals();

		include_once($addonPathCode."/mark_page.php");
		
		//CLICK COUNTER
		$page->head_script .= "\nvar bbc_clickcounterpage='".base64_encode(strrev($page->title))."';\n";
		$page->head_js[] = $addonRelativeCode.'/BBCClickCounter.js';
		
		self::end_time($start);

	}

	static function WhichPage($path){		
		global $config, $langmessage, $addonPathCode, $gpAdmin, $addon_current_id;
		
		if( common::loggedIn() ){		
			
			if(!isset($langmessage[$addon_current_id])){
				
				$langsdir = $addonPathCode."/languages/";//do not change it
				$langmessage[$addon_current_id] = array();	
				$adminlang = $config["language"];
			
				// check if adminlang is set (If rif-multilang plugin is installed)
				$users	= gpFiles::Get('_site/users');
				if(!empty($users[$gpAdmin['username']]['adminlang'])){
					$adminlang = $users[$gpAdmin['username']]['adminlang'];			
				}
				
				//rif-multilang plugin (change adminlang link)
				if(isset($_GET['adminlang']))
					$adminlang = $_GET['adminlang'];
			
				//include default language file
				$langmessage[$addon_current_id] = self::PluginLangmessages($langsdir."en.main.inc");
				
				//overwrite default langfile 
				if(file_exists($addonPathCode."/languages/".$adminlang.".main.inc")){					
					$addlangmessages = self::PluginLangmessages($langsdir.$adminlang.".main.inc");
					$langmessage[$addon_current_id] = self::ThreeDimArray($addlangmessages, $langmessage[$addon_current_id]);
				}
			}
					
			self::pluginstuninst($path);	
		}
		
		if(file_exists($addonPathCode.'/01.php'))
			include($addonPathCode.'/01.php');
	
		self::ClickCount();

		return $path;
	}
	
	//plugin langmessage file include
	static function PluginLangmessages($Path){
		global $addon_current_id;
		
		$langmessage = array();
		include($Path);
		
		//Check langmessage pluginid key if exists
		if(isset($langmessage[$addon_current_id]) && is_array($langmessage[$addon_current_id]))
			$langmessage = $langmessage[$addon_current_id];
		
		return $langmessage;
	}
	
	static function ThreeDimArray($addlangmessages, $langmessages){
		
		foreach($addlangmessages as $key => $val){
			if(!is_array($val))
				continue;
		
			if(!isset($langmessages[$key]))
				$langmessages[$key] = array();
			$addlangmessages[$key] = $addlangmessages[$key]+$langmessages[$key];
			
			foreach($val as $_key => $_val){
				if(!is_array($_val))
					continue;
				if(!isset($langmessages[$key][$_key]))
					$langmessages[$key][$_key] = array();
				$addlangmessages[$key][$_key] = $addlangmessages[$key][$_key]+$langmessages[$key][$_key];				
			}
		
		}
		return $addlangmessages+$langmessages;
	}
	
	static function LastToArchive($last, $ctime){
		global $addonPathData;
		
		if(empty($last['traffic']))
			return false;
		
		$_last = $last;
		$year = date("Y",$ctime);
		$month = date("m",$ctime);
		
		$_prev = array();
		$_prev['pages'] = $_last['pages'];
		foreach ($_last['traffic'] as $i => $v){
			
			$y = date("Y", $v['time']);
			$m = date("m", $v['time']);
			
			if($year.$month > $y.$m){
				
				$_prev['traffic'][$y.'/'.$m][] =  $v;
				$_prev['lastvisit'][$y.'/'.$m] =  $v['time'];
				unset($_last['traffic'][$i]);
			}else{
				$_last['lastvisit'] = $v['time'];
			}
			
		}
		
		//SAVE to previous month folder';
		if(!empty($_prev['traffic'])){
			foreach ($_prev['traffic'] as $arhfolder => $value){
				
				$prevfolder = $addonPathData.'/archives/'.$arhfolder.'/counter';				
				$_prev['traffic'] = $value;

				gpFiles::SaveArray($prevfolder.'/pages.inc', 'pages', $_prev['pages']);
				unset($_prev['pages']);
				gpFiles::SaveArray($prevfolder.'/last_'.$_prev['lastvisit'][$arhfolder].'.php', 'last', $_prev);
			}			
		}
		
		//SAVE to this month folder';
		if(!empty($_last['traffic']) && isset($_last['lastvisit'])){
			$folder = $addonPathData.'/archives/'.$year.'/'.$month.'/counter';
			
			foreach($_last['traffic'] as $traffic)
				$rows[] = $traffic;
			$_last['traffic'] = $rows;				
			
			gpFiles::SaveArray($folder.'/pages.inc', 'pages', $_last['pages']);
			unset($_last['pages']);
			gpFiles::SaveArray($folder.'/last_'.$_last['lastvisit'].'.php', 'last', $_last);
		}		
			
		return true;
	}
	
	//JQUERY AJAX CLICKS 	
 	static function ClickCount(){			
	
		if(isset($_GET['ClickStatSave'])){

			if(common::loggedIn())
				exit;
		
			if(!isset($_GET['page']))
				exit;
			if(!isset($_GET['allelements']))
				exit;
	
			$page = base64_decode($_GET['page']);
			$page = strrev($page);
			if(trim($page) == "")
				exit;
	
			$allclicknames = base64_decode($_GET['allelements']);
			if(trim($allclicknames) == "")
				exit;
			
			$allclicknames = urldecode($allclicknames);	
			$allclicknames = json_decode($allclicknames);
	
			if(!is_array($allclicknames))
				exit;	
 	
			$clickname = $_GET['ClickStatSave'];
			if(!in_array($clickname, $allclicknames))
				exit;
	
			self::ClickStatSave($page, $clickname, $allclicknames);
			exit; 
		}		
	}

	
	//JQUERY AJAX CLICKS save
	function ClickStatSave($page, $elemname, $allelements=array()){
		global $addonPathData, $gp_index;
		
		if(!isset($gp_index[urldecode($page)]))
			return;
		
		$page = $gp_index[urldecode($page)];		
		$pagefile = $addonPathData.'/clickstats/'.$page.'.php';
		
		//time		
		$g = gpFiles::Get( $addonPathData.'/config.php', 'bbc_config');
		$timeoffset = $g['BBC_TIME_OFFSET'];
		
		$ctime = time() + ($timeoffset * 60);		
		//
		
		//include pagefile (array $clickstats) 
		$clickstats = array();
		
		if(file_exists($pagefile)){			
			include($pagefile);
		}		
		
		if(isset($clickstats[$elemname]['lastclick'])){
			
			//allow new click save after each 5 sec
			if($clickstats[$elemname]['lastclick']+5 > $ctime)
				return;
			
			//detect ip addresses for block multiple clicks if needed
			if(isset($clickstats[$elemname]['iplist'])){
				$getip = self::getIP();
				if(array_key_exists($getip, $clickstats[$elemname]['iplist'])){
					$lastiptime = $clickstats[$elemname]['iplist'][$getip];
					//if($lastiptime)
					return;
				}
			}				
			
			$y = date("Y", $clickstats[$elemname]['lastclick']);
			$m = date("m", $clickstats[$elemname]['lastclick']);
			$year = date("Y", $ctime);
			$month = date("m", $ctime);
			
			//make archive if needed
			if($year.$month > $y.$m){
								
				$folder = $addonPathData.'/archives/'.$y.'/'.$m.'/clickstats/';
				
				gpFiles::SaveArray($folder.$page.'.php', 'clickstats', $clickstats);

				//sanitize clickstats
				//self::SanitizeClickStats();//if empty vars only files deleted if not corresponding pages exists				
				$clickstats = self::SanitizeClickStats($page, $allelements, $clickstats);
				
				foreach($clickstats as $e => $i){
					unset($clickstats[$e]['monthclicks']);
				}				
			}
		}
		//
		
		//Save clickstat file		
		$daynr = date("d", $ctime);	
		
		if(isset($clickstats[$elemname])){
			$clickstats[$elemname]['count'] = $clickstats[$elemname]['count'] + 1;
			$clickstats[$elemname]['monthclicks'][$daynr][] = $ctime;
			$clickstats[$elemname]['lastclick'] = $ctime;
		}else{
			$clickstats[$elemname]['count'] = 1;
			$clickstats[$elemname]['monthclicks'][$daynr][] = $ctime;
			$clickstats[$elemname]['lastclick'] = $ctime;
			
			//detect ip addresses for block multiple clicks if needed
			if(isset($clickstats[$elemname]['iplist'])){
				$ip = self::getIP();
				if(!array_key_exists($ip))
					$clickstats[$elemname]['iplist'][$ip] = $ctime;
			}
			
		}
	
		gpFiles::SaveArray($pagefile, 'clickstats', $clickstats);		
	}
	
	function getIP(){
		$ip = getenv("HTTP_CLIENT_IP")?:
		getenv("HTTP_X_FORWARDED_FOR")?:
		getenv("HTTP_X_FORWARDED")?:
		getenv("HTTP_FORWARDED_FOR")?:
		getenv("HTTP_FORWARDED")?:
		getenv("REMOTE_ADDR");

		return $ip;
	}
	
	static function OnlineCounter($traffic, $maxonlinetime, $counter=array(0,0)){
		
		$countvisitors = $counter[0];
		$countrobots = $counter[1];		
		foreach($traffic as $i => $data){
			if($data['time'] >= $maxonlinetime){
				if(isset($data['robot']))
					$countrobots++;
				else
					$countvisitors++;
			}
		}
		
		return array($countvisitors, $countrobots);
	}
		
	static function OnlineVisitorGadget(){
		global $addonPathData;
		
		$g = gpFiles::Get( $addonPathData.'/config.php', 'bbc_config');
		if(!$g)
			return;
		
		if(isset($g['BBC_KILL_STATS']) && $g['BBC_KILL_STATS'] == 1)
			return;
	
		$now = time() + ($g['BBC_TIME_OFFSET'] * 60);		
		$maxonlinetime = $now - $g['BBC_MAXTIME'];
		$countarray = array(0,0);

		if(!file_exists($addonPathData.'/counter/last.php'))
			return "";

		include($addonPathData.'/counter/last.php');
		
		if(empty($last))
			return;
		
		$traffic = $last["traffic"];		
		unset($last);
		$countarray = self::OnlineCounter($traffic, $maxonlinetime, $countarray);
	
		//chack from archive
		$y = date('Y',  $maxonlinetime);
		$m = date('m',  $maxonlinetime);		
		$folder = $addonPathData.'/archives/'.$y.'/'.$m.'/counter/';
		
		if($traffic[0]["time"] >= $maxonlinetime && file_exists($folder)){
			
			foreach (glob($folder."*.php") as $filename)
				$files[] = $filename;
				
			if(!empty($files)){
				rsort($files);			
				include($files[0]);
				$archtraffic = $last["traffic"];		
				unset($last);
				$countarray = self::OnlineCounter($archtraffic, $maxonlinetime, $countarray);
			}
		}
		$vis = '<a class="rif-bbc-online-visitors">'.$countarray[0].'</a>';
		$rob = '<a class="rif-bbc-online-robots">'.$countarray[1].'</a>';
		$html = '%s';		
		if (common::LoggedIn())
			$html = common::Link("Admin_BBC_Detailed_Stats", '%s', '', 'title="'.gpOutput::SelectText('Site Statistics').'"');		
						
		$text = gpOutput::GetAddonText('There are {count-visitors} VISITORS and the {count-robots} ROBOTS online currently',$html);
		echo '<span class="rif-bbc-online-counter">'.str_replace(array('{count-visitors}','{count-robots}'),array($vis,$rob), $text).'</span>';

	}	
}


?>
