<?php defined('is_running') or die('Not an entry point...');

function publication_date()
{
	global $page,$gp_index,$title,$addonFolderName,$config,$langmessage,$gp_titles;
	if (!isset($gp_index[$title]) || !$page->fileModTime)
		return;
	$in=common::LoggedIn();
	$p =& $gp_titles[$gp_index[$title]];//shortcut
	if (!$in && (isset($p['hide_publication_date']) || isset($p['hide_last_update'])))
		return;
	$a = $config['addons'][$addonFolderName];
	if (!isset($a['prior'])) {//use defaults
		$a['textc']='Published on %s.'; //aka created
		$a['textu']='Last updated on %s.';
		$a['date']='m/d/Y, G:i:s';
		$a['extc']=true;
		$a['extu']=true;
		$a['e_tdayc']='Published today.';
		$a['e_tdayu']='Last updated today.';
		$a['e_ydayc']='Published yesterday.';
		$a['e_ydayu']='Last updated yesterday.';
		$a['e_daysc']='Published %d days ago.';
		$a['e_daysu']='Last updated %d days ago.';
		$a['e_dnumc']=30;
		$a['e_dnumu']=30;
		$a['stylec']='margin:1em 0; font:italic normal 12px Verdana, sans-serif; text-align:left; color:inherit; background-color:inherit;';
		$a['styleu']='margin:1em 0; font:italic normal 12px Verdana, sans-serif; text-align:left; color:inherit; background-color:inherit;';
		$a['prior']='c';
		$a['disablec']=false;
		$a['disableu']=false;
	}
	if (!isset($a['timezone'])) {//use defaults - new in v.1.03
		$a['timezone'] = date_default_timezone_get(); //default time zone
	}
	if ($in)
	{
		$hp = admin_tools::HasPermission('Admin_Publication_Date');
		if (isset($_GET['switch_publication_date']))
		{
			if ($hp)
			{
				if ($_GET['switch_publication_date']=='hide')
					$p['hide_publication_date']=true;
				else
					unset($p['hide_publication_date']);//show
				admin_tools::SavePagesPHP();
			}
			else
			{
				message($langmessage['not_permitted']);
			}
		}
		if (isset($_GET['switch_last_update']))
		{
			if ($hp)
			{
				if ($_GET['switch_last_update']=='hide')
					$p['hide_last_update']=true;
				else
					unset($p['hide_last_update']);//show
				admin_tools::SavePagesPHP();
			}
			else
			{
				message($langmessage['not_permitted']);
			}
		}
		if ($hp)
		{
			$s = isset($p['hide_publication_date'])? 'hidden':'shown'; //status
			$c = isset($p['hide_publication_date'])? 'show':'hide'; //command
			$page->admin_links[] = array($title,'Publication date '.$s,'switch_publication_date='.$c);
			$s = isset($p['hide_last_update'])?'hidden':'shown';
			$c = isset($p['hide_last_update'])? 'show':'hide';
			$page->admin_links[] = array($title,'Last update '.$s,'switch_last_update='.$c);
		}
	}
	if ($a['timezone']!='') {
		date_default_timezone_set($a['timezone']); //default time zone
	}
	$tc=$tu=false;//times, when file was created and updated
	if (isset($page->file_stats)) //available after gpEasy 2.4
	{
		$tc=$page->file_stats['created'];
		$tu=$page->file_stats['modified'];
	}
	elseif (isset($page->fileModTime))
	{
		$tu=$page->fileModTime;
	}
	$sc=$su='';
	if ($a['extc'] || $a['extu'])
	{
		$today=date('Ymd');//today date
	}
	if ($tc && !$a['disablec'] && !isset($p['hide_publication_date']))
	{
		$dt=time()-$tc; //difference in seconds
		if ($a['extc'] && $dt<86400*$a['e_dnumc']) //if date is younger than n days (n*24*60*60seconds)
		{
			if ($today==date('Ymd',$tc)) //today==page creation date
				$s=$a['e_tdayc'];
			elseif ($today==date('Ymd',$tc+86400)) //today==page creation date+1day
				$s=$a['e_ydayc'];
			else
				$s=str_replace('%d',(int)($dt/86400),$a['e_daysc']);
		}
		else
		{
			$s=str_replace('%s',date($a['date'],$tc),$a['textc']);
		}
		$sc = '<div style="'.$a['stylec'].'">'.$s.'</div>';
		//echo $page->fileModTime.'='.filemtime(gpFiles::PageFile($title));
	}
	if ($tu && !$a['disableu'] && !isset($p['hide_last_update']))
	{
		$dt=time()-$tu; //difference in seconds
		if ($a['extu'] && $dt<86400*$a['e_dnumu']) //if date is younger than n days (n*24*60*60seconds)
		{
			if ($today==date('Ymd',$tu)) //today==page modification date
				$s=$a['e_tdayu'];
			elseif ($today==date('Ymd',$tu+86400)) //today==page modification date+1day
				$s=$a['e_ydayu'];
			else
				$s=str_replace('%d',(int)($dt/86400),$a['e_daysu']);
		}
		else
		{
			$s=str_replace('%s',date($a['date'],$tu),$a['textu']);
		}
		$su = '<div style="'.$a['styleu'].'">'.$s.'</div>';
	}
	echo $a['prior']=='c'? $sc.$su : $su.$sc;
}
